//package net.sf.testium.configuration;
//
//import java.io.File;
//import java.io.IOException;
//
//import javax.xml.parsers.ParserConfigurationException;
//import javax.xml.parsers.SAXParser;
//import javax.xml.parsers.SAXParserFactory;
//
//import net.sf.testium.executor.CustomInterface;
//import net.sf.testium.selenium.WebDriverInterface;
//
//import org.testtoolinterfaces.utils.GenericTagAndStringXmlHandler;
//import org.testtoolinterfaces.utils.RunTimeData;
//import org.testtoolinterfaces.utils.TTIException;
//import org.testtoolinterfaces.utils.Trace;
//import org.testtoolinterfaces.utils.XmlHandler;
//import org.xml.sax.Attributes;
//import org.xml.sax.SAXException;
//import org.xml.sax.XMLReader;
//
///**
// * @author Arjan Kranenburg 
// * 
// *  <ElementDefinitions>
// *    <ElementDefinitionsLink>...</ElementDefinitionsLink>
// *    <DefineElement>...</DefineElement>
// *    <DefineElementList>...</DefineElementList>
// *  </ElementDefinitions>
// * 
// */
//
//public class LoadCustomStepsXmlHandler extends XmlHandler
//{
//	private static final String START_ELEMENT = "CustomStepDefinitions";
//
//	private static final String CUSTOMSTEP_DEFINITIONS_LINK_ELEMENT = "CustomStepDefinitionsLink";
//
//	private CustomStepXmlHandler myCustomStepXmlHandler;
//	private GenericTagAndStringXmlHandler myCustomStepDefinitionsLinkXmlHandler;
//
//	private final RunTimeData myRtData;
//	private final CustomInterface myInterface;
//	
//	public LoadCustomStepsXmlHandler( XMLReader anXmlReader, 
//                                      RunTimeData anRtData,
//                                      CustomInterface anInterface )
//	{
//	    super(anXmlReader, START_ELEMENT);
//	    Trace.println(Trace.CONSTRUCTOR);
//
//		myRtData = anRtData;
//		myInterface = anInterface;
//		
//		myCustomStepXmlHandler = new CustomStepXmlHandler(anXmlReader, anRtData, anInterface);
//		this.addElementHandler(myCustomStepXmlHandler);
//
//		myCustomStepDefinitionsLinkXmlHandler = new DefineElementListXmlHandler(anXmlReader, anRtData, anInterface);
//		this.addElementHandler(myCustomStepDefinitionsLinkXmlHandler);
//
//		myCustomStepDefinitionsLinkXmlHandler = new GenericTagAndStringXmlHandler(anXmlReader, CUSTOMSTEP_DEFINITIONS_LINK_ELEMENT);
//		this.addElementHandler(myCustomStepDefinitionsLinkXmlHandler);
//	}
//
//	@Override
//	public void handleStartElement(String aQualifiedName)
//	{
//		// nop
//	}
//
//	@Override
//	public void handleCharacters(String aValue)
//	{
//		// nop
//	}
//
//	@Override
//	public void handleEndElement(String aQualifiedName)
//	{
//		// nop
//	}
//
//	@Override
//	public void processElementAttributes(String aQualifiedName, Attributes att)
//	{
//		// nop
//	}
//
//	@Override
//	public void handleGoToChildElement(String aQualifiedName)
//	{
//		// nop
//	}
//
//	@Override
//	public void handleReturnFromChildElement(String aQualifiedName, XmlHandler aChildXmlHandler)
//		throws TTIException
//	{
//	    Trace.println(Trace.UTIL, "handleReturnFromChildElement( " + 
//		    	      aQualifiedName + " )", true);
//		    
//		if (aQualifiedName.equalsIgnoreCase( CUSTOMSTEP_DEFINITIONS_LINK_ELEMENT ))
//    	{
//			String fileName = myCustomStepDefinitionsLinkXmlHandler.getValue();
//			myCustomStepDefinitionsLinkXmlHandler.reset();
//
//			fileName = myRtData.substituteVars(fileName);
//			try {
//				LoadCustomStepsXmlHandler.loadElementDefinitions( new File( fileName ), myRtData, myInterface );
//			} catch (ConfigurationException ce) {
//				throw new TTIException( "Failed to load element Definitions from file: " + fileName, ce );
//			}
//    	} else if ( aQualifiedName.equalsIgnoreCase(myCustomStepXmlHandler.getStartElement()) )
//    	{
//    		try {
//				myCustomStepXmlHandler.defineElement();
//			} catch (ConfigurationException e) {
//	    		myCustomStepXmlHandler.reset();
//				throw new TTIException( "Failed to load element Definition", e );
//			}
//    		myCustomStepXmlHandler.reset();
//    	} else if ( aQualifiedName.equalsIgnoreCase(myDefineElementListXmlHandler.getStartElement()) )
//		{
//			try {
//				myDefineElementListXmlHandler.defineElementList();
//			} catch (ConfigurationException e) {
//				myDefineElementListXmlHandler.reset();
//				throw new TTIException( "Failed to load elementList Definition", e );
//			}
//			myDefineElementListXmlHandler.reset();
//		}
//		// else ignore
//	}
//
//	public static void loadElementDefinitions(File aFile, RunTimeData anRtData, WebDriverInterface anInterface)
//			throws ConfigurationException {
//		Trace.println(Trace.UTIL, "loadElementDefinitions( " + aFile.getName()
//				+ " )", true);
//		// create a parser
//		SAXParserFactory spf = SAXParserFactory.newInstance();
//		spf.setNamespaceAware(false);
//		SAXParser saxParser;
//		try {
//			saxParser = spf.newSAXParser();
//			XMLReader xmlReader = saxParser.getXMLReader();
//
//			// create a handler
//			LoadCustomStepsXmlHandler handler = new LoadCustomStepsXmlHandler(xmlReader, anRtData, anInterface);
//
//			// assign the handler to the parser
//			xmlReader.setContentHandler(handler);
//
//			// parse the document
//			xmlReader.parse(aFile.getAbsolutePath());
//		} catch (ParserConfigurationException e) {
//			Trace.print(Trace.UTIL, e);
//			throw new ConfigurationException(e);
//		} catch (SAXException e) {
//			Trace.print(Trace.UTIL, e);
//			throw new ConfigurationException(e);
//		} catch (IOException e) {
//			Trace.print(Trace.UTIL, e);
//			throw new ConfigurationException(e);
//		}
//	}
//}
